#include "stdio.h"
#include "icsnVC40.h"
#include <Winsock2.h>

enum enumEtherType{
	//this is a list of Ether Types supported by vspy at the day of making this 
	eEtherTypeRaw		= 0x0000,
	eEtherTypeIPv4		= 0x0800,
	eEtherTypeARP		= 0x0806,
	eEtherTypeIPv6		= 0x86DD,
	eEtherTypeIEEE1722	= 0x22f0,
	eEtherTypePTP		= 0x88F7,
	eEtherTypeVLANInner	= 0x8100,
	eEtherTypeVLANOuter = 0x88A8,
	
};

enum ennumIPProtocal{
	//IP Protocals
	eProtocolHOPOPT = 0x00,
	eProtocolTCP	= 0x06,
	eProtocolUDP	= 0x11,
	eProtocolICMP	= 0x01,
	eProtocolICMPv6 = 0x58,
	eProtocolIGMP	= 0x02,
	eProtocolRAW	= 0xFF,

};


struct EthernetHeader{
	unsigned char Destination[6];
	unsigned char Source[6];
	unsigned char EtherType[2];
};

struct IPv4Header{
	EthernetHeader parentHeader;
	//u_char verstionIHL;
//#define version 0xF0
//#define IHL 0x0F
	unsigned char Version:4; //only works on big endian computers
	unsigned char IHL:4;
	unsigned char TOS;
	unsigned char TotalLength[2];
	unsigned char Identification[2];	
	unsigned char FragmentOffset[2];
#define	IP_DF 0x4000			/* dont fragment flag */
#define	IP_MF 0x2000			/* more fragments flag */
	unsigned char TTL;
	unsigned char Protocol;
	unsigned char HeaderChecksum[2];
	unsigned char SourceAddress[4];
	unsigned char DestinationAddress[4];
	unsigned char IPOptions[4];

};

 struct IPv6Header{	
	EthernetHeader parentHeader;
	unsigned char Version:4;
	unsigned char TrafficClass;
	unsigned int FlowLabel:20;
	unsigned char PatloadLength[2];
	unsigned char NextHeader;
	unsigned char HopLimit;
	unsigned char SourceAddress[16];
	unsigned char DestinationAddress[16];

};


