#pragma once
#include "icsnVC40.h"
#include "Messages.h"
#include "Time.h"

class Display
{
protected:
	enum enumMessageType{
		eEthernet =	1,
		eIPv4,
		eARP,
		eIPv6,
		eIEEE1722,
		ePTP,
		eVlANInner,
		eVlanOuter,
		eIPV4ProtocolHOPOPT,
		eIPV4ProtocolITCP,
		eIPV4ProtocolUDP,
		eIPV4ProtocolICMP,
		eIPV4ProtocolICMPv6,
		eIPV4ProtocolIGMP,

	};

	Messages * m_pMessages;
	void DisplayMessage(icsSpyMessage * message);

	void DisplayCAN(icsSpyMessage * message);
	void DisplayEthernet(icsSpyMessage * message);
	void DisplayCANFD(icsSpyMessage * message);

	SDateTime GetSpyMessageTimeSec(const icsSpyMessage & stMsg );

	char * getNetworkString(unsigned char networkID);
	unsigned int IdentifyEthernet(icsSpyMessage * message);

	void PrintEthernet(icsSpyMessage * message);
	void PrintIPv4(icsSpyMessage * message);
	void PrintIPv6(icsSpyMessage * message);
	void PrintTime(icsSpyMessage * message); 
	void PrintHex(unsigned char * value, int size, bool indent);
	void PrintMacAddress(unsigned char * value, int size);
	void PrintIPAddress(unsigned char * value, int size);

public:
	Display(Messages * messages);
	void DisplayALL();
	void DisplayMessage(int index);
	
};

