// ---------------------------------------------------------------------------

#ifndef MessagesH
#define MessagesH
// ---------------------------------------------------------------------------

#include <vector>
#include "icsnVC40.h"

#define VSB_HEADERSIZE 10
#define SIZEOFEDPSIZE 4

// timestamp id fields
#define  HARDWARE_TIMESTAMP_ID_NONE  (unsigned char)0
#define  HARDWARE_TIMESTAMP_ID_VSI  (unsigned char)1
#define  HARDWARE_TIMESTAMP_ID_AVT_716  (unsigned char)2
#define  HARDWARE_TIMESTAMP_ID_NI_CAN  (unsigned char)3
#define  HARDWARE_TIMESTAMP_ID_NEOVI  (unsigned char)4
#define  HARDWARE_TIMESTAMP_ID_AVT_717 (unsigned char)5
#define  HARDWARE_TIMESTAMP_ID_NEOv6_VCAN  (unsigned char)6
#define  HARDWARE_TIMESTAMP_ID_DOUBLE_SEC  (unsigned char)7
#define  HARDWARE_TIMESTAMP_ID_NEORED_10US  (unsigned char)8
#define  HARDWARE_TIMESTAMP_ID_NEORED_25NS  (unsigned char)9


// Constants used to calculate the timestamp
#define NEOVI_TIMESTAMP_2   0.1048576
#define NEOVI_TIMESTAMP_1   0.0000016

#define NEOVIPRO_VCAN_TIMESTAMP_2   0.065536
#define NEOVIPRO_VCAN_TIMESTAMP_1   0.000001

#define NEOVI6_VCAN_TIMESTAMP_2   0.065536
#define NEOVI6_VCAN_TIMESTAMP_1   0.000001

#define NEOVI_RED_TIMESTAMP_2_25NS   107.3741824
#define NEOVI_RED_TIMESTAMP_1_25NS   0.000000025

#define NEOVI_RED_TIMESTAMP_2_10US 42949.67296
#define NEOVI_RED_TIMESTAMP_1_10US 0.00001

#define NEOVIPRO_VCAN_TIMESTAMP_2_US 65536.0
#define NEOVIPRO_VCAN_TIMESTAMP_1_US 1.0


#define EDPSECTIONSTRINGSIZE 12

using namespace std;


enum enumMessageType{
	eEthernet,
	eIPv4,
	eARP,
	eIPv6,
	eIEEE1722,
	ePTP,
	eVlANInner,
	eVlanOuter,
	eIPV4ProtocolHOPOPT,
	eIPV4ProtocolITCP,
	eIPV4ProtocolUDP,
	eIPV4ProtocolICMP,
	eIPV4ProtocolICMPv6,
	eIPV4ProtocolIGMP,
};

typedef struct {
	icsSpyMessage * messages;	
	SpyMsgTime startTimeStamp;
	int numberofMessage;
}SpyMessages;

typedef struct 
{
	void * pExtraDataPtr;
	int length;
}pExtraDataPtrHandler;

class Messages
{
private:
	
protected:

	FILE * m_pFile;

    size_t m_nMessages;
	char * m_pEDPSection;
	icsSpyMessage * m_pMessages;
	SpyMsgTime m_startTimeStamp;

    std::vector<std::pair<char*, int> > m_edps;
    
    int ReadEDPSelction();
    bool ReadMessage(unsigned long theNumOfMsgs,  unsigned int fileversion);

    unsigned long Read103Header();
    bool Read104();
	
	void VSBMessageToNormal(icsSpyMessage * first, icsSpyMessageVSB * second);	

	bool fRead(char * location, int size);
	void fSead(int location, int position);
	
public:

	double GetSpyTimeSec(const SpyMsgTime & StartTime, const SpyMsgTime & StopTime );
    bool Read(char * filename);
	int Count(); 
	SpyMsgTime getStartTimeStamp();
	icsSpyMessage * operator[](int index);

	Messages();
	~Messages();

};

#endif
