#pragma once

#define FourYearsN 	5049216000000000LL
#define Year366N 	1264896000000000LL	// --- 366*24*3600*40000000 	ticks per minute
#define Year365N 	1261440000000000LL	// --- 365*24*3600*40000000 	ticks per minute

//#define MonthN	103680000000000LL	// --- 30*24*3600*40000000 	ticks per minute
#define DayN 	3456000000000LL 	// --- 24*3600*40000000 	ticks per minute
#define HourN	144000000000LL 		// --- 3600*40000000 	ticks per minute
#define MinN	2400000000LL 		// --- 60*40000000 	ticks per minute
#define SecN	40000000LL 			// --- 40000000 		ticks per second
#define FracN	400000LL 			// --- 400000			ticks per 1/100 of a second
#define MsN	40000LL 			// 	ticks per msecond
#define UsN	40LL 				// 	ticks per usecond

typedef struct _SDateTime{                                    
 	unsigned long options;   	// Bitfield with options flags.
	unsigned short usec;  		// --- microseconds (0-999)
	unsigned short msec;  		// --- milliseconds (0-999)
	unsigned char Sec;	   	// --- Seconds (00-59)
	unsigned char Min;		// --- (00-59)
	unsigned char Hour;		// --- (00-23)
	unsigned char DOW;		// --- (01-07)
	unsigned char Day;		// --- (01-31)
	unsigned char Month;		// --- (01-12)
	unsigned short Year;		// --- (2000-2999)
	unsigned char reserved; // ---- Always Zero
} SDateTime;

class Time
{
public:
	Time(void);
	~Time(void);
	static SDateTime GetRTC (long long int T);
	
private:
	static long long int RTC_TicksToRTC (long long int T, SDateTime	*rtc );
	static long long int RTC_GetKernalTicksOffset(void);
	static unsigned long long RTC_MonthsToDays(unsigned int month, unsigned int year);
	static unsigned long long RTC_YearsToDays(unsigned int year);
	static long long int RTC_TicksToMonths(long long int t, long long int * months,unsigned long year);
	static int RTC_ComputeDOW(int day, int month,int year);
	static long long int M64 (long long int A, long long int B);
	static long long int D64 (long long int A, long long int B);
};

